import javax.microedition.lcdui.*;

public abstract class GameCanvas extends Canvas {

private int keyp,keyr,keysr;
private static final int fp = 10;
private static final int FP = 1<<fp;
private Image buffer;
private Graphics g;
private boolean start, pause;
public int width,height;
private Thread t;

public GameCanvas(){
super();
setFullScreenMode(true);
width = getWidth();
height = getHeight();
buffer = Image.createImage(width, height);
g = buffer.getGraphics();
}

public void paint(Graphics g0){
if(start)
g0.drawImage(buffer, 0, 0, 20);
}

public void keyPressed(int k){
keyp = k;
keyr = k;
int bit = k << FP;
keysr |= bit;
}

public void keyReleased(int k){
if(keyp == k)
keyp = 0;
if(keyr == k)
keyr = 0;
if(isKeyRepeated(k, true)){
int bit = k << FP;
keysr &= ~bit;
}
}

public boolean isKeyPressed(int key){
int k = getKeyPressed();
return k == key;
}

public boolean isKeyRepeated(int key, boolean multi){
return multi?((keysr & (key<<FP))!=0):key == keyr;
}

public int getKeyPressed(){
int ret = keyp;
keyp = 0;
return ret;
}

public int getKeyRepeated(){
return keyr;
}

public int getKeysRepeated(){
return keysr;
}

public void flushGraphics(){
repaint(0, 0, width, height);
serviceRepaints();
}

public abstract void run();

public void start(){
t = new Thread(new Runnable(){
public void run(){
while(start){
if(!pause){
run();
}
}
}
});
start = true;
t.start();
}

public void stop(){
start = false;
t = null;
}

public void pause(){
pause = true;
}

public void resume(){
pause = false;
}

public void step(long delay){
try{
Thread.sleep(delay);
}catch(InterruptedException ie){}
}

public void destroy(){
keyp = keysr = keyr = 0;
buffer = null;
g = null;
}

}
